import { Logger, Module } from '@nestjs/common';
import { OrmMongoCompanyService } from './ormmongocompany.service';
import { OrmMongoCompanyController } from './ormmongocompany.controller';
import { DepartmentModule } from './department/department.module';
import { StaffsModule } from './staffs/staffs.module';
import { RouterModule } from '@nestjs/core';

@Module({
  imports: [
    // The router register is commonly placed in app.module
    // However, I suggest to put registation in the 2nd level module only
    // for easy management (i.e. not for root and children level)
    RouterModule.register([
      {
        path: 'ormmongo-company',
        module: OrmMongoCompanyModule,
        children: [
          {
            path: 'departments',
            module: DepartmentModule,
          },
          {
            path: 'staffs',
            module: StaffsModule,
          },
        ],
      },
    ]),
    DepartmentModule,
    StaffsModule,
  ],
  controllers: [OrmMongoCompanyController],
  providers: [Logger, OrmMongoCompanyService],
})
export class OrmMongoCompanyModule {}
